-- Lockbox IDs to check for while trading
local boxIds = {
	["4632"] = true,		-- Ornate Bronze Lockbox
	["4633"] = true,		-- Heavy Bronze Lockbox
	["4634"] = true,		-- Iron Lockbox
	["4636"] = true,		-- Strong Iron Lockbox
	["4637"] = true,		-- Steel Lockbox
	["4638"] = true,		-- Reinforced Steel Lockbox
	["5758"] = true,		-- Mithril Lockbox
	["5759"] = true,		-- Thorium Lockbox
	["5760"] = true,		-- Eternium Lockbox
	["31952"] = true,		-- Khorium Lockbox
	["43622"] = true,		-- Froststeel Lockbox
	["43624"] = true,		-- Titanium Lockbox
	["45986"] = true,		-- Tiny Titanium Lockbox
	["68729"] = true,		-- Elementium Lockbox
	["88567"] = true,		-- Ghost Iron Lockbox
	["116920"] = true,		-- True Steel Lockbox
	["121331"] = true,		-- Leystone Lockbox
}

-- Button initialisation
local btn

-- Event Frame
local EventFrame = CreateFrame("Frame")

function loadAddon()
	localizedClass, englishClass, classIndex = UnitClass("player")
	if(classIndex == 4) then
		EventFrame:RegisterEvent("TRADE_TARGET_ITEM_CHANGED")
		EventFrame:RegisterEvent("TRADE_CLOSED")

		-- Get localised spell name for "Pick Lock"
		local name, rank, icon, castingTime, minRange, maxRange, spellID = GetSpellInfo(1804)
		local localisedPickPocket = name

		-- Lock Pick button to show left of the not trade frame
		btn = CreateFrame("Button", "btn", UIParent, "ActionButtonTemplate, SecureActionButtonTemplate");
		btn:SetAttribute("type", "spell");
		btn:SetAttribute("spell", localisedPickPocket);
		btn:SetPoint("RIGHT", TradeRecipientItem7ItemButton, "LEFT", -10, 0)
		btn:SetFrameStrata("TOOLTIP")
		btn:SetWidth(36)
		btn:SetHeight(36)
		btn.icon:SetTexture(GetSpellTexture(localisedPickPocket))
		btn:Hide()
	end
end

EventFrame:RegisterEvent("ADDON_LOADED")
EventFrame:SetScript("OnEvent", function(self, event, ...)
	if(event == "TRADE_TARGET_ITEM_CHANGED") then
		local slotId = ...
		-- If it's the no trade slot
		if(slotId == 7) then
			-- Try to extract the item id of the item link
			local itemLink = GetTradeTargetItemLink(slotId)
			if(itemLink ~= nil) then
				local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4, Suffix, Unique, LinkLvl, Name = string.find(itemLink, "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
				-- If it's a lockbox
				if(boxIds[Id] ~= nil) then
					btn:Show()
				else
					btn:Hide()
				end
			else
				btn:Hide()
			end
		end
	-- Only load the addon if the player is a rogue
	elseif(event == "ADDON_LOADED" and ... == "LockboxCracker") then
		-- The button icon sometimes seems not to be loaded after addon init, so wait a couple of secs
		C_Timer.After(5, function()
			loadAddon()
		end)
	elseif(event == "TRADE_CLOSED") then
		btn:Hide()
	end
end)